--ݿű1.01.21汾
create or replace function sp_Upgrade() RETURNS varchar AS $$
declare count11 varchar(2);
declare code varchar(2);
declare isexist integer;
begin
select count(*) into count11 from VERSION_INFO where version='1.21';
if count11 = '0' then
--//////////ݿű1.01.1汾
    select count(*) into isexist from information_schema.columns where (table_name = 'users' or table_name = 'users') and (column_name='usercertid' or column_name='USERCERTID');
    if isexist=0 then
        ALTER TABLE USERS ADD USERCERTID varchar(500) NULL;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'exam_master' or table_name = 'EXAM_MASTER') and (column_name='ca_signature' or column_name='CA_SIGNATURE');
    if isexist=0 then
        ALTER TABLE exam_master ADD ca_signature varchar(6000) NULL;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'exam_diagnosis_history' or table_name = 'exam_diagnosis_history') and (column_name='ca_signature' or column_name='CA_SIGNATURE');
    if isexist=0 then
        ALTER TABLE exam_diagnosis_history ADD ca_signature varchar(6000) NULL;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'exam_diagnosis_history' or table_name = 'exam_diagnosis_history') and (column_name='electronic_stamp' or column_name='ELECTRONIC_STAMP');
    if isexist=0 then
        ALTER TABLE exam_diagnosis_history ADD electronic_stamp bytea;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'exam_master' or table_name = 'EXAM_MASTER') and (column_name='electronic_stamp' or column_name='ELECTRONIC_STAMP');
    if isexist=0 then
        ALTER TABLE exam_master ADD electronic_stamp bytea;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'users' or table_name = 'users') and (column_name='datetime_stamp' or column_name='DATETIME_STAMP');
    if isexist=0 then
        ALTER TABLE USERS ADD DATETIME_STAMP varchar(2000) NULL;
	end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'EXAM_MASTER' or table_name = 'exam_master') and (column_name='usercertid' or column_name='USERCERTID');
    if isexist=0 then
        ALTER TABLE EXAM_MASTER ADD USERCERTID VARCHAR(500) NULL;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'EXAM_MASTER' or table_name = 'exam_master') and (column_name='datetime_stamp' or column_name='DATETIME_STAMP');
    if isexist=0 then
        ALTER TABLE EXAM_MASTER ADD DATETIME_STAMP VARCHAR(2000) NULL;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'EXAM_DIAGNOSIS_HISTORY' or table_name = 'exam_diagnosis_history') and (column_name='usercertid' or column_name='USERCERTID');
    if isexist=0 then
        ALTER TABLE EXAM_DIAGNOSIS_HISTORY ADD USERCERTID VARCHAR(500) NULL;
    end if;
    select count(*) into isexist from information_schema.columns where (table_name = 'EXAM_DIAGNOSIS_HISTORY' or table_name = 'exam_diagnosis_history') and (column_name='datetime_stamp' or column_name='DATETIME_STAMP');
    if isexist=0 then
        ALTER TABLE EXAM_DIAGNOSIS_HISTORY ADD DATETIME_STAMP VARCHAR(2000) NULL;
    end if;
    select exam_class_code into code from exam_class_dict where exam_class_code='3';
    if code is null then
        insert into exam_class_dict (SERIAL_NO, EXAM_CLASS_CODE, EXAM_CLASS_NAME, IS_VALID, ITEM_STATUS) VALUES (3, '3', 'Holter ECG', '1', 1);
    end if;
    select exam_item_code into code from exam_item_dict where exam_item_code='4';
    if code is null then
        insert into exam_item_dict (SERIAL_NO, exam_item_code,exam_item_name,is_valid,item_status,currency_unit) values(7,'4','HRV','1','1','USD');	
        insert into exam_class_item_dict values('1','4');
    end if;
    select exam_item_code into code from exam_item_dict where exam_item_code='5';
    if code is null then
        insert into exam_item_dict (SERIAL_NO, exam_item_code,exam_item_name,is_valid,item_status,currency_unit) values(8,'5','VCG','1','1','USD');
        insert into exam_class_item_dict values('1','5');
    end if;
    select exam_item_code into code from exam_item_dict where exam_item_code='11';
    if code is null then
        INSERT INTO EXAM_ITEM_DICT (SERIAL_NO, EXAM_ITEM_CODE, EXAM_ITEM_NAME, IS_VALID, ITEM_STATUS, CURRENCY_UNIT) VALUES (5, '11', '18-lead Resting ECG', '1', 1, 'USD');
        INSERT INTO EXAM_CLASS_ITEM_DICT (EXAM_CLASS_CODE, EXAM_ITEM_CODE) VALUES ('1', '11');
    end if;
    select exam_item_code into code from exam_item_dict where exam_item_code='12';
    if code is null then
        INSERT INTO EXAM_ITEM_DICT (SERIAL_NO, EXAM_ITEM_CODE, EXAM_ITEM_NAME, IS_VALID, ITEM_STATUS, CURRENCY_UNIT) VALUES (11, '12', '3-lead Holter ECG', '1', 1, 'USD');
        INSERT INTO EXAM_CLASS_ITEM_DICT (EXAM_CLASS_CODE, EXAM_ITEM_CODE) VALUES ('3', '12');
    end if;
    select exam_item_code into code from exam_item_dict where exam_item_code='13';
    if code is null then
        INSERT INTO EXAM_ITEM_DICT (SERIAL_NO, EXAM_ITEM_CODE, EXAM_ITEM_NAME, IS_VALID, ITEM_STATUS, CURRENCY_UNIT) VALUES (12, '13', '12-lead Holter ECG', '1', 1, 'USD');
        INSERT INTO EXAM_CLASS_ITEM_DICT (EXAM_CLASS_CODE, EXAM_ITEM_CODE) VALUES ('3', '13');
    end if;
--///////////	
--//////////ݿű1.11.2汾
--ɾͼ
    drop view  if exists view_patinfo_exammaster_exam;
    drop view  if exists view_examed;
    drop view  if exists view_registed_exam;
    drop view  if exists view_requested_exam;
    drop view  if exists view_allexamlist;
    alter table exam_master alter column body_height type varchar(10) ;
    alter table exam_master alter column body_weight type varchar(10) ;
    alter table exam_master alter column systolic_pressure type varchar(10) ;
    alter table exam_master alter column diastolic_pressure type varchar(10) ;
--ѯбͼ
    CREATE OR REPLACE VIEW view_allexamlist AS 
    SELECT exam_master.heart_rate, exam_master.p_duration, exam_master.pr_interval, 
    exam_master.qrs_duration, exam_master.qt_interval, exam_master.qtc_interval, 
    exam_master.p_axis, exam_master.qrs_axis, exam_master.t_axis, 
    exam_master.regist_date_time, exam_master.req_date_time, 
    exam_master.order_date_time, exam_master.age, 
    exam_master.change_status AS change_status_name, exam_master.exam_item, 
    exam_master.performed_by, exam_master.result_status, 
    exam_disable_history.disable_date_time, 
    exam_disable_history.user_id AS disable_user_name, 
    exam_disable_history.reason, exam_master.fee, 
    exam_master.currency_unit AS currency_unit_name, exam_master.doctor_advice, 
    exam_master.priority, exam_master.priority AS priority_name, 
    exam_master.exam_date_time, exam_master.diag_result, 
    req_dept_dict.dept_name AS req_dept_name, exam_master.sickbed_no, 
    exam_master.visit_id, exam_master.patient_source AS patient_source_name, 
    exam_master.exam_id, exam_master.appoint_id, 
    exam_master.result_status AS exam_result_status_name, 
    exam_master.filedelivery_status AS filedelivery_name, 
    exam_master.upload_status AS upload_name, 
    exam_master.export_status AS export_name, 
    exam_master.print_status AS print_name, 
    exam_master.exam_class AS exam_class_name, 
    exam_master.exam_item AS exam_item_name, 
    exam_master.performed_by AS dept_name, exam_master.device_id AS device_name, 
    user2.user_name AS technician_name, p.patient_id, p.patient_name, 
    exam_master.req_physician, p.sex AS sex_name, 
    exam_master.age_unit AS age_unit_name, 
    user1.user_name AS reporter_name, exam_master.report_date_time, 
    exam_master.severity AS severity_name, exam_master.record_guid, 
    exam_master.custom_1, exam_master.custom_2, p.date_of_birth, 
    race_dict.race_flag AS race_name, exam_master.consultation_purpose
    FROM exam_master
    left join users user2 on user2.user_id=exam_master.technician
    left join users user1 on user1.user_id=exam_master.reporter
    LEFT JOIN req_dept_dict ON req_dept_dict.dept_code  =  req_dept 
    LEFT JOIN exam_disable_history ON  exam_master.exam_id  = exam_disable_history.exam_id , 
    patient_info p
    LEFT JOIN sex_dict ON sex_dict.sex_flag  = p.sex 
    LEFT JOIN race_dict ON race_dict.race_flag  = p.race 
    WHERE p.patient_id  =  exam_master.patient_id ;
--ȡûȨͼ
    CREATE OR REPLACE VIEW view_user_right AS 
    SELECT role_of_user.user_id, right_of_role.right_id, right_of_role.dept_code, 
    right_detail.right_name
    FROM right_of_role
    JOIN role_class ON right_of_role.role_class_id = role_class.class_id
    JOIN right_detail ON right_of_role.right_id = right_detail.right_id
    JOIN role_of_user ON role_class.class_id = role_of_user.class_id
    WHERE (right_of_role.role_class_id IN ( SELECT role_of_user_nickname.class_id
    FROM role_of_user role_of_user_nickname
    WHERE role_class.is_valid = 1));

    update CURRENCY_UNIT_DICT set is_default='0' where unit_code='USD';
    select count(*) into count11 from VERSION_INFO where version<'1.21';

    delete from ROLE_OF_USER;
    if(count11>'0') then 
        delete from RIGHT_OF_ROLE;
    end if;
    delete from RIGHT_OF_ROLE;
    delete from ROLE_CLASS ;
    INSERT INTO ROLE_CLASS (CLASS_ID, CLASS_NAME, IS_VALID, DESCRIPTION) VALUES (1, 'Exam.', 1, '');
    INSERT INTO ROLE_CLASS (CLASS_ID, CLASS_NAME, IS_VALID, DESCRIPTION) VALUES (2, 'Diagnose', 1, '');
    INSERT INTO ROLE_CLASS (CLASS_ID, CLASS_NAME, IS_VALID, DESCRIPTION) VALUES (3, 'Print', 1, '');
    INSERT INTO ROLE_CLASS (CLASS_ID, CLASS_NAME, IS_VALID, DESCRIPTION) VALUES (4, 'System Setting', 1, '');
    INSERT INTO ROLE_CLASS (CLASS_ID, CLASS_NAME, IS_VALID, DESCRIPTION) VALUES (5, 'Hospital Administrator', 1, '');

    INSERT INTO ROLE_OF_USER (USER_ID, CLASS_ID) VALUES ('ECG', 1);
    INSERT INTO ROLE_OF_USER (USER_ID, CLASS_ID) VALUES ('ECG', 2);
    INSERT INTO ROLE_OF_USER (USER_ID, CLASS_ID) VALUES ('ECG', 3);
    INSERT INTO ROLE_OF_USER (USER_ID, CLASS_ID) VALUES ('ECG', 4);
    INSERT INTO ROLE_OF_USER (USER_ID, CLASS_ID) VALUES ('ECG', 5);
--1.21ʼȨޣ˲ɾRIGHT_OF_ROLE
    if(count11>'0') then
--ҽȨ޵
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 1, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 8, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 2, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 5, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 6, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 12, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 14, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (1, 4, 1);
--ҽȨ޵
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (2, 7, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (2, 8, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (2, 2, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (2, 33, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (2, 14, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (2, 32, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (2, 18, 1);
--ӡ
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (3, 9, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (3, 14, 1);
--ϵͳ
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (4, 24, 1);
--ԱȨ޵
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (5, 12, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (5,14, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (5, 31, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (5, 10, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (5, 21, 1);
        INSERT INTO RIGHT_OF_ROLE (ROLE_CLASS_ID, RIGHT_ID, DEPT_CODE) VALUES (5, 22, 1);
    end if;
  
--//ݿű1.21.21汾
    drop view  if exists view_allexamlist;
    alter table exam_record_collection alter column race  type varchar(20) ;
    alter table DEPT_DICT    alter column PHONE_NUMBER  type varchar(30) ;
    alter table EXAM_APPOINTS alter column PHONE_NUMBER  type varchar(30) ;
    alter table exam_record_collection alter column phone_number  type varchar(30) ;
    alter table ECG_DEVICES_DICT alter column DEVICE_MODLE  type varchar(30) ;
    select count(*) into isexist from information_schema.columns where (table_name = 'EXAM_MASTER ' or table_name = 'exam_master') and (column_name='chk_date_time' or column_name='CHK_DATE_TIME');
    if isexist=0 then
        ALTER TABLE EXAM_MASTER ADD CHK_DATE_TIME timestamp NULL;
    end if;
    
    select count(*) into isexist from information_schema.columns where (table_name = 'EXAM_MASTER ' or table_name = 'exam_master') and (column_name='diag_conclusion' or column_name='DIAG_CONCLUSION');
    if isexist=0 then
        ALTER TABLE EXAM_MASTER ADD DIAG_CONCLUSION VARCHAR(4000) NULL;
    end if;

    CREATE OR REPLACE VIEW view_allexamlist AS 
    SELECT exam_master.heart_rate, exam_master.p_duration, exam_master.pr_interval, 
    exam_master.qrs_duration, exam_master.qt_interval, exam_master.qtc_interval, 
    exam_master.p_axis, exam_master.qrs_axis, exam_master.t_axis, 
    exam_master.regist_date_time, exam_master.req_date_time, 
    exam_master.order_date_time, exam_master.age, 
    exam_master.change_status AS change_status_name, exam_master.exam_item, 
    exam_master.performed_by, exam_master.result_status, 
    exam_disable_history.disable_date_time, 
    exam_disable_history.user_id AS disable_user_name, 
    exam_disable_history.reason, exam_master.fee, 
    exam_master.currency_unit AS currency_unit_name, exam_master.doctor_advice, 
    exam_master.priority, exam_master.priority AS priority_name, 
    exam_master.exam_date_time, exam_master.diag_result, 
    req_dept_dict.dept_name AS req_dept_name, exam_master.sickbed_no, 
    exam_master.visit_id, exam_master.patient_source AS patient_source_name, 
    exam_master.exam_id, exam_master.appoint_id, 
    exam_master.result_status AS exam_result_status_name, 
    exam_master.filedelivery_status AS filedelivery_name, 
    exam_master.upload_status AS upload_name, 
    exam_master.export_status AS export_name, 
    exam_master.print_status AS print_name, 
    exam_master.exam_class AS exam_class_name, 
    exam_master.exam_item AS exam_item_name, 
    exam_master.performed_by AS dept_name, exam_master.device_id AS device_name, 
    user2.user_name AS technician_name, p.patient_id, p.patient_name, 
    exam_master.req_physician, p.sex AS sex_name, 
    exam_master.age_unit AS age_unit_name, 
    user1.user_name AS reporter_name, exam_master.report_date_time, 
    exam_master.severity AS severity_name, exam_master.record_guid, 
    exam_master.custom_1, exam_master.custom_2, p.date_of_birth, 
    race_dict.race_flag AS race_name, exam_master.consultation_purpose,exam_master.chk_date_time,exam_master.diag_conclusion 
    FROM exam_master
    LEFT JOIN req_dept_dict ON req_dept_dict.dept_code = exam_master.req_dept
    LEFT JOIN exam_disable_history ON exam_master.exam_id = exam_disable_history.exam_id
    left join users user2 on user2.user_id=exam_master.technician
    left join users user1 on user1.user_id=exam_master.reporter,
    patient_info p
    LEFT JOIN sex_dict ON sex_dict.sex_flag = p.sex
    LEFT JOIN race_dict ON race_dict.race_flag = p.race
    WHERE p.patient_id = exam_master.patient_id;
    update VERSION_INFO set version='1.21'; 
--//ǰѾ1.21汾ʱHolterֶ
else
    select exam_class_code into code from exam_class_dict where exam_class_code='3';
    if code is null then
        insert into exam_class_dict (SERIAL_NO, EXAM_CLASS_CODE, EXAM_CLASS_NAME, IS_VALID, ITEM_STATUS) VALUES (3, '3', 'Holter ECG', '1', 1);
    end if;
    select exam_item_code into code from exam_item_dict where exam_item_code='12';
    if code is null then
        INSERT INTO EXAM_ITEM_DICT (SERIAL_NO, EXAM_ITEM_CODE, EXAM_ITEM_NAME, IS_VALID, ITEM_STATUS, CURRENCY_UNIT) VALUES (11, '12', '3-lead Holter ECG', '1', 1, 'USD');
        INSERT INTO EXAM_CLASS_ITEM_DICT (EXAM_CLASS_CODE, EXAM_ITEM_CODE) VALUES ('3', '12');
    end if;
    select exam_item_code into code from exam_item_dict where exam_item_code='13';
    if code is null then
        INSERT INTO EXAM_ITEM_DICT (SERIAL_NO, EXAM_ITEM_CODE, EXAM_ITEM_NAME, IS_VALID, ITEM_STATUS, CURRENCY_UNIT) VALUES (12, '13', '12-lead Holter ECG', '1', 1, 'USD');
        INSERT INTO EXAM_CLASS_ITEM_DICT (EXAM_CLASS_CODE, EXAM_ITEM_CODE) VALUES ('3', '13');
    end if;
end if;
return '0';
end;
$$ LANGUAGE plpgsql;

select sp_Upgrade();
--ÿűʱҪ޸ĺµsqlca_signature
